// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MakeTerrain.h"

#include "MainFrm.h"
#include "OpenglView.h"
#include "MakeTerrainView.h"



extern CMakeTerrainApp theApp;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_SELECTIONNER_TEXTURE, OnSelectionnerTexture)
	ON_UPDATE_COMMAND_UI(ID_SELECTIONNER_TEXTURE, OnUpdateSelectionnerTexture)
	ON_COMMAND(ID_SUPPRIMER_TEXTURE, OnSupprimerTexture)
	ON_UPDATE_COMMAND_UI(ID_SUPPRIMER_TEXTURE, OnUpdateSupprimerTexture)
	ON_COMMAND(ID_CHARGER_AVEC_PAINT, OnChargerAvecPaint)
	ON_COMMAND(ID_DETAIL, OnDetail)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	

	if (!AddToolBar (m_wndToolBar,IDR_MAINFRAME,CBRS_TOP)) return -1;
	if (!AddToolBar (m_wndToolBarManipTerrain,IDR_TOOLBAR_MANIP_TERRAIN,CBRS_RIGHT)) return -1;
	if (!AddToolBar (m_wndToolBarDessin,IDR_TOOLBAR_DESSINS,CBRS_LEFT)) return -1;
	if (!AddToolBar (m_wndToolBarAction,IDR_ACTION,CBRS_TOP)) return -1;
	
	


	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}


	{
	
		// Initialize dialog bar m_wndMyDialogBar
		if (!BitmapBar.Create(this, IDD_JEREMY_BITMAP_RESIZE_BAR_BACKGROUND,
			CBRS_RIGHT | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_HIDE_INPLACE
			| CBRS_SIZE_DYNAMIC,
			1000))
//			CG_ID_VIEW_MYDIALOGBAR+1))
		{
			TRACE0("Failed to create dialog bar ResizeBar\n");
			return -1;		// fail to create
		}

		BitmapBar.EnableDocking(CBRS_ALIGN_ANY);

		EnableDocking(CBRS_ALIGN_ANY);
		DockControlBar(&BitmapBar);
		BitmapBar.ReplaceDialogue (&DlgBitmapList,IDD_JEREMY_BITMAP_LISTE);


	}


	
	ShowWindow (SW_SHOWMAXIMIZED);

	return 0;
}

// Ajouter une ToolBar
BOOL CMainFrame::AddToolBar (CToolBar &ToolBarToAdd,UINT IdToolBar,UINT Pos)
{
	if (!ToolBarToAdd.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | Pos //TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!ToolBarToAdd.LoadToolBar(IdToolBar))
	{
		TRACE0("Failed to create toolbar\n");
		return FALSE;      // fail to create
	}


	ToolBarToAdd.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&ToolBarToAdd);
	return TRUE;
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers



BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	SIZE size;
	RECT rc;


	GetClientRect (&rc);
	size.cx = rc.right / 2;
	size.cy = rc.bottom;
	m_wndSplitter.CreateStatic (this,1,2);
	m_wndSplitter.CreateView (0,0,RUNTIME_CLASS (CMakeTerrainView),size,pContext);
	m_wndSplitter.CreateView (0,1,RUNTIME_CLASS (COpenglView),size,pContext);
	return TRUE;
}

// Ajouter une image  la liste
void CMainFrame :: AddBitmap (CString FileName)
{
	DlgBitmapList.AddBitmap (FileName);
}





void CMainFrame::OnUpdateSelectionnerTexture(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable ((DlgBitmapList.GetBitmapCount () != 0));
	
}





void CMainFrame::OnSupprimerTexture() 
{
	// TODO: Add your command handler code here
	DWORD index;
	index = DlgBitmapList.DeleteSelectedTexture ();
	if (index == -1)
	{
		AfxMessageBox ("Il faut slectionner une textre avant");
		return;
	}
	
	// Slectionner la texture.
	theApp.DeleteTexture (index);
}

void CMainFrame::OnUpdateSupprimerTexture(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}


HBITMAP CMainFrame :: GetTextureHandle (int index)
{
	return DlgBitmapList.GetTextureHandle (index);
}


void CMainFrame::OnChargerAvecPaint() 
{
	// TODO: Add your command handler code here
	CString FileName;
	CString str;
	int index;
	index = DlgBitmapList.GetSelectedBitmap ();
	if (index == LB_ERR) return;
	FileName = DlgBitmapList.Liste.GetPathFileName (index);
	str.Format ("C:\\Program Files\\Accessoires\\MSPAINT \"%s\"",FileName);
	WinExec (str,SW_SHOW);

}

void CMainFrame::OnSelectionnerTexture() 
{
	// TODO: Add your command handler code here
	// TODO: Add your command handler code here
	DWORD index;
	index = DlgBitmapList.GetSelectedBitmap ();
	if (index == -1)
	{
		AfxMessageBox ("Il faut slectionner une textre avant");
		return;
	}
	
	// Slectionner la texture.
	theApp.SelectTexture (index);
}

void CMainFrame::OnDetail() 
{
	DWORD index;
	index = DlgBitmapList.GetSelectedBitmap ();
	if (index == -1)
	{
		AfxMessageBox ("Il faut slectionner une textre avant");
		return;
	}
	
	// Slectionner la texture.
	theApp.SelectDetailTexture (index);
}
