#ifndef OBJET_TROIS_D_H
#define OBJET_TROIS_D_H

#include "stdafx.h"
#include "TerrainType.h"



class	Objet;
class CShip;


typedef struct
{
	unsigned char * pBit;
	int Width,Height;
} TEXTUREINFO;

class TextureInfo : public CObject
{

public:
	int IdTexture;
	TEXTUREINFO TextInfo;
	CString FileName;
	int FileIndexe;

	// Chargement de la texture  partir de FileName
	BOOL Load ();

	TextureInfo (CString filename,BOOL bChargementNormal = FALSE);
	TextureInfo(int Cx,int Cy);
	~TextureInfo ();
	int GetID () {return IdTexture;}
	void SetID (int IDinit) {IdTexture = IDinit;}
	TEXTUREINFO * GetTextureInfo () {return &TextInfo;}
	void SetIndexe (int IndexeInit) {FileIndexe = IndexeInit;}
	int GetIndexe () {return FileIndexe;}
	int Heiht () {return TextInfo.Height;}
	int Width () {return TextInfo.Width;}
	unsigned char * GetBit () {return TextInfo.pBit;}
	int GetBitSize () {return TextInfo.Width * TextInfo.Height * NBYTE;}


	void GetRgb (int i,int j,BYTE &r,BYTE &g,BYTE &b);
	void SetRgb (int i,int j,BYTE r,BYTE g,BYTE b);

	// Indique si l'objet est correctement charg
	BOOL IsLoading (){return (TextInfo.pBit != NULL);}
	BOOL SetBit (BYTE * pBitSet);
	BOOL CreateBitmap (CBitmap &Bmp);
	BOOL CreateBitmap (CBitmap * pBmp);
	void GreyLevel ();


};

class CTextBmp : public CObject
{
	TextureInfo * pText;
	CBitmap * pBmp;
	int Niveau;
	int Numero;
public:
	CTextBmp (TextureInfo * pTextInit,CBitmap * pBmpInit);
	~CTextBmp ();

	CBitmap * GetBitmap () {return pBmp;}
	TextureInfo * GetTexture () {return pText;}
	
	void SetBitmap (CBitmap * pBmpInit) {pBmp = pBmpInit;}
	void SetTexture (TextureInfo * pTextInit) {pText = pTextInit;}

	int GetNiveau () {return Niveau;}
	int GetNumero () {return Numero;}
	void SetNiveau (int Init) {Niveau = Init;}
	void SetNumero (int Init) {Numero = Init;}

};


class CMatrice : public CObject
{
public:
	CMatrice ();
	~CMatrice ();
	void SetMatrice (GLfloat Rot [16],GLfloat anx,GLfloat any,GLfloat anz);
	void MulMatrice (GLfloat Rot [16],GLfloat M [16]);
	void CopyMatrice (GLfloat RotSource [16],GLfloat RotDest [16]);
	POINTASC RotatePoint (GLfloat mat [16],POINTASC pt);
	POINTASC RotatePoint (GLfloat mat [16],GLfloat x,GLfloat y,GLfloat z);
	void MatriceToIdentity (GLfloat Mat [16]);
	void Inverse (GLfloat mat [16]);

};


class CMissile : public CObject
{

public:
	int nbinc;		// Nombre d'incrementation
	POINTASC point;
	POINTASC pointPrev; // ancienne position du missil
	GLfloat dx;
	GLfloat dy;
	GLfloat dz;
	GLfloat matref [16];


	CMissile (GLfloat x,GLfloat y,GLfloat z,GLfloat dxinit,GLfloat dyinit,GLfloat dzinit,GLfloat mat [16]);

	~CMissile ();

	POINTASC GetPoint () {return point;}
	POINTASC GetDirection ();
	virtual BOOL IsValid ();
	virtual BOOL IsMissilDirect () {return TRUE;}
	virtual void  ResetCible ();

	virtual void Deplace ();
	virtual unsigned long GetIdPlayerCible () {return 0;}


};

class CTextureInfo : public CObject
{

public:
	int IdTexture;
	TEXTUREINFO TextInfo;
	CString FileName;
	int FileIndexe;

	// Chargement de la texture  partir de FileName
	BOOL Load ();

	CTextureInfo (CString filename,BOOL bChargementNormal = FALSE);
	CTextureInfo(int Cx,int Cy);

	~CTextureInfo ();
	int GetID () {return IdTexture;}
	void SetID (int IDinit) {IdTexture = IDinit;}
	TEXTUREINFO * GetTextureInfo () {return &TextInfo;}
	void SetIndexe (int IndexeInit) {FileIndexe = IndexeInit;}
	int GetIndexe () {return FileIndexe;}
	int Heiht () {return TextInfo.Height;}
	int Width () {return TextInfo.Width;}

	void SetRgb (int i,int j,BYTE r,BYTE g,BYTE b);
	void GetRgb (int i,int j,BYTE &r,BYTE &g,BYTE &b);


};



// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
//							OBJET
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
class	Objet : public CObject
{
private:
	int NbFacette;
	int NbVertex;
	int NbTotal;
	int NbTextCoord;
	int IdObjet;
	CString FileName;



	HGLOBAL hglbPoint;
	HGLOBAL hglbFace;
	HGLOBAL hglbTextCoord;
	POINTASC ** pPoint;
	POINTASC ** pTextCoord;
	FACETTE ** pFacette;


	

	void AllocMemory ();
	void DestroyMemory ();

	TEXTUREINFO Texture;
	CObList TextureListe;
	int Rayon;



public:
	int noCallListe;

	Objet (int nVertexInit,int nFacetteInit);
	~Objet ();

	void SetFileName (CString FileNameInit);
	CString GetFileName () {return FileName;}
	int GetRayon () {return Rayon;}


	int GetNbFacette () {return NbFacette;}
	int GetNbVertex () {return NbVertex;}
	int GetNbTotal () {return NbTotal;}
	int GetNbTextCoord () {return NbTextCoord;}

	void SetPoint (int no,GLfloat x,GLfloat y,GLfloat z);
	POINTASC * GetPoint (int no);

	void SetFacette (int no,int a,int b,int c,int TextIndex);
	FACETTE * GetFacette (int no);
	void InitCubeCollision ();
	TEXTUREINFO * GetTexture () {return &Texture;}
	BOOL IsTextureValid () {return (Texture.pBit) ? TRUE : FALSE;}
	void AddTexture (CString fileName,int indexe);
	void SetFacetteNormale (int no,NORMAL * norm);

	void AllocTextureCoord (int NbreCoord);
	POINTASC * GetTextCoord (int no);

	
	BOOL SetTextCoord (int no,GLfloat x,GLfloat y,GLfloat z);
	BOOL SetTextCoordIndex (int no,int Ta,int Tb,int Tc);
	BOOL SelectTexture (int IndexeDeListe);
	void MakeIndexeTexture ();
	int GetIdObjet () {return IdObjet;}
	CObList * GetTextureListe () {return &TextureListe;}
	int GetTextureCount () {return TextureListe.GetCount ();}
	int GetTextureId (int no);

	// Renvoit la longueur du cote du cube de collision sur X
	GLfloat GetCoteX ();



};



class CShip : public CObject
{

public:
	int NbVertex;
	int NbTotal;
	GLfloat dx,dy,dz;
	GLfloat x,y,z;
	GLfloat vitesse;
	GLfloat PhiAxMem;
	GLfloat PhiAyMem;
	GLfloat LockAngle;
	GLfloat vitesseMax;

	GLfloat anx,any,anz;


	GLfloat matref [16];
	GLfloat matorient [16];

	int NoObj;
	BOOL bExplose;
	int IdExplosion;
	int IndexTriangle;



	virtual void Rot (GLfloat ax,GLfloat ay,GLfloat az);
	void Raz ();
	POINTASC * GetPoint (int index);
	POINTASC * GetPointCollision (int index);
	BOOL bDestroyed;




public:
	BOOL IsDestroyed () {return bDestroyed;}
	void Destroy () {bDestroyed = TRUE;}
	int GetRayon () {return obj->GetRayon ();}

	Objet * obj;	
	
	CShip (Objet * objinit);
	~CShip ();

	virtual void Deplace ();
	Objet * GetObjet3d () {return obj;}
	void CopyMatrice (GLfloat matToCopy [16]);
	
	void InitDirection (GLfloat xdir,GLfloat ydir,GLfloat zdir);
	void SetDirection (GLfloat xdir,GLfloat ydir,GLfloat zdir);

	void SetIndexFacette (int IndexTriangleInit) {IndexTriangle = IndexTriangleInit;}
	int GetIndexFacette () {return IndexTriangle;}
	
	void Explode ();
	BOOL IsExplode () {return bExplose;}
	void SetY (GLfloat yInit);

	void SetOrientation (GLfloat AngX,GLfloat AngZ);
	void SetOrientation (GLfloat xn,GLfloat yn,GLfloat zn,int no);

	void SetDep ();
	POINTASC Normal (float x,float y,float z,float vecx,float vecy,float vecz);

	virtual void Draw ();
	virtual void RotateTourelle (float an){return;}
	virtual void RotateCanon (float an){return;}


};



// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
//							CLASSE TANK
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
class CTank : public CShip
{
	// Le matrices de rfrences des autres lements
	GLfloat matrefTourelle [16];
	GLfloat matrefCanon [16];

	// Les angles de matrice des lments supplmentaire
	float AngTourelle;
	float AngCanon;
	
public:	
	CString FileNameCorps;
	CString FileNameTourelle;
	CString FileNameCannon;

	// Les objets suplmentaires
	Objet * objTourelle;	
	Objet * objCanon;

public:
	CTank (Objet * objinit);
	~CTank ();

	virtual void RotateTourelle (float an);
	virtual void RotateCanon (float an);
	virtual void Rot (GLfloat ax,GLfloat ay,GLfloat az);
	virtual void Draw ();
};




// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
//							OBJET DE TEXTURE ANIMEE
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------

class AnimTexture : public CObject
{
	CObList TextureListe;
public:
	AnimTexture ();
	~AnimTexture ();
	BOOL AddTexture (CString fileName);
	
	int GetCount () {return TextureListe.GetCount ();}
	void DrawTexture (int no,GLfloat x,GLfloat y,GLfloat z,GLfloat width,GLfloat height);

};





// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
//							OBJET EXPLOSION
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------


class Explosion : public CObject
{

	GLfloat mul;
	Objet * obj;
	int * tabint;

public:
	Explosion (Objet * objinit);
	~Explosion ();
	void CreateListeAnimation ();
	int GetIdListe (int no);
	int CreateList (int IdTexture);
	void SetNormal (FACETTE * pFacette,int no);
	int GetNbAnimation (){return obj->GetTextureCount ();}

	void DrawExplosion (int no);
	void DrawExplosion (int no,GLfloat matrice [16]);

};

// Un objetde camra
class CCamera : public CObject
{

public:
	
	GLfloat anx,any;	// angle d'oreintation
	GLfloat dx,dy,dz;	// vecteur de direction
	GLfloat Distance;
	GLfloat x;
	GLfloat y;
	GLfloat z;
	GLfloat matref [16];

	CCamera (GLfloat ax,GLfloat ay,GLfloat x,GLfloat y ,GLfloat z,GLfloat DistanceInit);
	CCamera ();
	~CCamera ();

	POINTASC GetOrientation ();
	void Rotate (GLfloat ax,GLfloat ay);
	// void IncDistance (GLfloat inc);
	void IncDistance (GLfloat inc,GLfloat ApprochMax);

	GLfloat GetDistance () {return Distance;}
	void SetOrientation (GLfloat anxinit,GLfloat anyinit);
	POINTASC GetPosition ();
	void SetPosition (int xinit,int yinit,int zinit);
	void CCamera :: SetMatrice (GLfloat matriceinit [16]);

};

class CLight : public CObject
{

	MATERIEL mat;
	GLfloat Pos [4];	// Position de la lumire
	GLUquadricObj * quadLight;
	GLfloat radius;
	GLenum no;
public:
	CLight ();
	~CLight ();
	void SetAmbiant (GLfloat r,GLfloat g,GLfloat b,GLfloat alpha);
	void SetDiffuse (GLfloat r,GLfloat g,GLfloat b,GLfloat alpha);
	void SetSpecular (GLfloat r,GLfloat g,GLfloat b,GLfloat alpha);
	void SetEmission (GLfloat r,GLfloat g,GLfloat b,GLfloat alpha);
	void SetShineness (GLfloat shiness) {mat.Shineness [0] = shiness;}
	void SetRadius (GLfloat radiusinit){radius = radiusinit;}
	void SetNumLight (GLenum noinit);
	void SetPosition (GLfloat xinit,GLfloat yinit,GLfloat zinit);
	void SetPosX (GLfloat init) {Pos [0] = init;}
	void SetPosY (GLfloat init) {Pos [1] = init;}
	void SetPosZ (GLfloat init) {Pos [2] = init;}
	MATERIEL * GetMateriel () {return &mat;}

	void Enable ();
	void Disable ();




	// Liste des fonction OpenGl
	void glSetPosition (GLfloat xinit,GLfloat yinit,GLfloat zinit);
	void glDrawLight ();


};



class CTextureListe : public CObject
{
	CObList Liste;

public:
	CTextureListe ();
	~CTextureListe ();
	
	BOOL AddTexture (CString FileName);
	CTextureInfo * GetTexture (int index);
	BOOL DeleteTexture (int index);

};


// Classe d'objet FOG
class CFog : public CObject
{
	GLint TypeFog;
	GLfloat FogColor[4];
	GLfloat FogDensity;
	GLfloat FogStart;
	GLfloat FogEnd;


public:
	CFog ();
	~CFog ();

	void SetTypeFog (GLint TypeFogInit) {TypeFog = TypeFogInit;}
	GLint GetTypeFog () {return TypeFog;}

	GLfloat GetFogStart () {return FogStart;}
	GLfloat GetFogEnd ()  {return FogEnd;}
	GLfloat GetDensity () {return FogDensity;}

	void SetFogStart (GLfloat FogStartInit) {FogStart = FogStartInit;}
	void SetFogEnd (GLfloat FogEndInit)  {FogEnd = FogEndInit;}
	void SetDensity (GLfloat FogDensityInit) {FogDensity = FogDensityInit;}


	void GetFogColor (GLfloat FogColorToInit [4]);
	void GetFogColor (GLfloat &R,GLfloat &G,GLfloat &B,GLfloat &Alpha);
	void SetFogColor (GLfloat R,GLfloat G,GLfloat B,GLfloat Alpha);

	GLfloat GetFogR () {return FogColor [0];}
	GLfloat GetFogG () {return FogColor [1];}
	GLfloat GetFogB () {return FogColor [2];}
	GLfloat GetFogAlpha () {return FogColor [3];}
	void MakeFog ();
	void CopyIn (CFog &cFog);


};

class CAlphaTest	: public CObject
{
	float Seuil;
	GLenum Type;
	BOOL bEnable;

public:
	CAlphaTest ();
	~CAlphaTest ();

	void SetSeuil(float SeuilInit) {Seuil = SeuilInit;}
	float GetSeuil() {return Seuil;}

	void SetType (GLenum TypeInit) {Type = TypeInit;}
	GLenum GetType () {return Type;}

	void MakeAlphaTest ();
	void Enable () {bEnable = TRUE;}
	void Disable () {bEnable = FALSE;}
	BOOL IsEnable () {return bEnable;}

};




// Classe de liste des vaisseaux
class CListShip	: public CObject
{
	CObList Liste;
public:
	CListShip ();
	~CListShip ();
	BOOL AddShip (CShip * pVais);
	BOOL DestroyShip (int index);
	void DestroyListe ();
	CShip * GetShip (int index);
	int GetCount () {return Liste.GetCount ();}
};



#endif
